#ifndef KATOPTRON_RESULTSDECL_HPP
#define KATOPTRON_RESULTSDECL_HPP

#include "katoptron.h"
#include "wObject.h"
#include "wTimer.h"
#include "wTimers.h"
#include "wTag.h"
#include "wMedium.h"
#include "wNode.h"
#include "wMem.h"
#include "Teuchos_ParameterList.hpp"

#include "wProblem.h"
#include "wContact.h"
#include "wMshData.h"
#include "wDisplayHook.h"
#include "wElement.h"

// Tpetra
#include "Stokhos_Tpetra_MP_Vector.hpp"
#include "Stokhos_Tpetra_Utilities_MP_Vector.hpp"
#include "Tpetra_ConfigDefs.hpp"

#include "Tpetra_Map.hpp"
#include "Tpetra_MultiVector.hpp"
#include "Tpetra_Vector.hpp"
#include "Tpetra_CrsGraph.hpp"
#include "Tpetra_CrsMatrix.hpp"

#include <Teuchos_Array.hpp>
#include <Teuchos_GlobalMPISession.hpp>
#include <Teuchos_oblackholestream.hpp>
#include <Teuchos_ScalarTraits.hpp>
#include <Teuchos_RCP.hpp>
#include "Teuchos_ParameterList.hpp"

#include "Kokkos_ViewFactory.hpp"
#include "Kokkos_Vector.hpp"

#include "wRandomField.h"
#include "wResults.h"
#include "wLazy.h"
#include "Map.h"
#include <map>
#include "EnsembleTraits.h"

/**
 * @brief Function to write results on disk using VTK formats.
 */
template <class Scalar, class LocalOrdinal, class GlobalOrdinal>
void writeResultsVTK(
    const katoptron::Problem &pbl,
    Teuchos::RCP<Tpetra::Vector<Scalar, LocalOrdinal, GlobalOrdinal>> xPost,
    Teuchos::RCP<katoptron::Map> map,
    Teuchos::RCP<RandomField<Scalar, Kokkos::DefaultExecutionSpace>> random_field,
    std::string name,
    size_t ast,
    bool final_result,
    bool write_txt);

#endif //KATOPTRON_RESULTSDECL_HPP
