/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WGROUPS_H
#define WGROUPS_H

#include "tbox.h"
#include "wObject.h"
#include <vector>
#include <string>
#include <memory>

namespace tbox
{

/**
 * @brief Handle group of several physical regions (tag)
 * @authors Adrien Crovato
 */
class TBOX_API Groups : public fwk::wSharedObject
{
public:
#ifndef SWIG
    std::shared_ptr<MshData> msh;
#endif
    std::vector<Group *> groups;

    Groups(std::shared_ptr<MshData> _msh, std::vector<int> const &nos);
    Groups(std::shared_ptr<MshData> _msh, std::vector<std::string> const &names);
    ~Groups();
};

} // namespace tbox

#endif //WGROUPS_H
