/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "wSource.h"
#include "wProblem.h"
#include "wTag.h"
#include "wElement.h"
#include "wNode.h"
#include <algorithm>
using namespace waves;

Source::Source(std::shared_ptr<MshData> _msh, int no) : Group(_msh, no)
{
    for (auto e : tag->elems)
        for (auto n : e->nodes)
            nodes.push_back(n);
    /*
    std::for_each(tag->elems.begin(), tag->elems.end(), [&](Element *e) { 
        std::for_each(e->nodes.begin(), e->nodes.end(), [&](Node *n) { 
            nodes.push_back(n); 
        });
    });
*/
    //pbl.srcs.push_back(this);
}

Source::Source(std::shared_ptr<MshData> _msh, std::string const &name) : Group(_msh, name)
{
    for (auto e : tag->elems)
        for (auto n : e->nodes)
            nodes.push_back(n);

    //pbl.srcs.push_back(this);
}

void Source::write(std::ostream &out) const
{
    out << "Source on " << *tag;
    out << "(" << nodes.size() << " nodes)";
    //std::for_each(nodes.begin(), nodes.end(), [&](Node *n) { out << '\t' << *n << '\n'; });
    //for(auto n : nodes) { out << '\t' << *n << '\n'; }
}
